"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var common_1 = require("./common");
function _fibonacci() {
    var a = 0;
    var b = 1;
    return function () {
        _a = [b, a + b], a = _a[0], b = _a[1];
        return a;
        var _a;
    };
}
function fibonacci(times) {
    var fib = _fibonacci();
    var num = fib();
    _.times(times, function () {
        num = fib();
    });
    return num;
}
exports.fibonacci = fibonacci;
function getDelayQueue(delayMs, exchange, routingKey) {
    return "delay." + delayMs + "." + exchange + "." + routingKey;
}
exports.getDelayQueue = getDelayQueue;
function getDelayQueueOptions(delayMs, exchange, routingKey) {
    return {
        durable: true,
        deadLetterExchange: exchange,
        deadLetterRoutingKey: routingKey,
        messageTtl: delayMs,
        expires: delayMs * 2,
    };
}
exports.getDelayQueueOptions = getDelayQueueOptions;
var strategies = (_a = {},
    _a[common_1.RetryStrategy.FIBONACCI] = function (task) {
        return task.initDelayMs * fibonacci(task.retryCount);
    },
    _a[common_1.RetryStrategy.EXPONENTIAL] = function (task) {
        return task.initDelayMs * Math.pow(2, task.retryCount);
    },
    _a[common_1.RetryStrategy.LINEAR] = function (task) {
        return task.initDelayMs * (task.retryCount + 1);
    },
    _a);
function getRetryDelayMs(task) {
    var strategy = strategies[task.retryStrategy];
    if (!strategy) {
        // Fallback to FIBONACCI
        strategy = strategies[common_1.RetryStrategy.FIBONACCI];
    }
    return strategy(task);
}
exports.getRetryDelayMs = getRetryDelayMs;
function registerEvent(events, source, target) {
    events.forEach(function (e) {
        source.on(e, function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return target.emit.apply(target, [e].concat(args));
        });
    });
}
exports.registerEvent = registerEvent;
var _a;
//# sourceMappingURL=helper.js.map